/*
 * Licensed to the Apache Software Foundation (ASF) under one
 * or more contributor license agreements.  See the NOTICE file
 * distributed with this work for additional information
 * regarding copyright ownership.  The ASF licenses this file
 * to you under the Apache License, Version 2.0 (the
 * "License"); you may not use this file except in compliance
 * with the License.  You may obtain a copy of the License at
 *
 *   https://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing,
 * software distributed under the License is distributed on an
 * "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
 * KIND, either express or implied.  See the License for the
 * specific language governing permissions and limitations
 * under the License.
 */
package org.apache.plc4x.java.opcua.readwrite;

import java.util.HashMap;
import java.util.Map;

// Code generated by code-generation. DO NOT EDIT.

public enum OpcuaNodeIdServicesVariableDiscrepancy {
  DiscrepancyAlarmType_EventId((int) 17081L),
  DiscrepancyAlarmType_EventType((int) 17082L),
  DiscrepancyAlarmType_SourceNode((int) 17083L),
  DiscrepancyAlarmType_SourceName((int) 17084L),
  DiscrepancyAlarmType_Time((int) 17085L),
  DiscrepancyAlarmType_ReceiveTime((int) 17086L),
  DiscrepancyAlarmType_LocalTime((int) 17087L),
  DiscrepancyAlarmType_Message((int) 17088L),
  DiscrepancyAlarmType_Severity((int) 17089L),
  DiscrepancyAlarmType_ConditionClassId((int) 17090L),
  DiscrepancyAlarmType_ConditionClassName((int) 17091L),
  DiscrepancyAlarmType_ConditionSubClassId((int) 17092L),
  DiscrepancyAlarmType_ConditionSubClassName((int) 17093L),
  DiscrepancyAlarmType_ConditionName((int) 17094L),
  DiscrepancyAlarmType_BranchId((int) 17095L),
  DiscrepancyAlarmType_Retain((int) 17096L),
  DiscrepancyAlarmType_EnabledState((int) 17097L),
  DiscrepancyAlarmType_EnabledState_Id((int) 17098L),
  DiscrepancyAlarmType_EnabledState_Name((int) 17099L),
  DiscrepancyAlarmType_EnabledState_Number((int) 17100L),
  DiscrepancyAlarmType_EnabledState_EffectiveDisplayName((int) 17101L),
  DiscrepancyAlarmType_EnabledState_TransitionTime((int) 17102L),
  DiscrepancyAlarmType_EnabledState_EffectiveTransitionTime((int) 17103L),
  DiscrepancyAlarmType_EnabledState_TrueState((int) 17104L),
  DiscrepancyAlarmType_EnabledState_FalseState((int) 17105L),
  DiscrepancyAlarmType_Quality((int) 17106L),
  DiscrepancyAlarmType_Quality_SourceTimestamp((int) 17107L),
  DiscrepancyAlarmType_LastSeverity((int) 17108L),
  DiscrepancyAlarmType_LastSeverity_SourceTimestamp((int) 17109L),
  DiscrepancyAlarmType_Comment((int) 17110L),
  DiscrepancyAlarmType_Comment_SourceTimestamp((int) 17111L),
  DiscrepancyAlarmType_ClientUserId((int) 17112L),
  DiscrepancyAlarmType_AddComment_InputArguments((int) 17116L),
  DiscrepancyAlarmType_ConditionRefresh_InputArguments((int) 17118L),
  DiscrepancyAlarmType_ConditionRefresh2_InputArguments((int) 17120L),
  DiscrepancyAlarmType_AckedState((int) 17121L),
  DiscrepancyAlarmType_AckedState_Id((int) 17122L),
  DiscrepancyAlarmType_AckedState_Name((int) 17123L),
  DiscrepancyAlarmType_AckedState_Number((int) 17124L),
  DiscrepancyAlarmType_AckedState_EffectiveDisplayName((int) 17125L),
  DiscrepancyAlarmType_AckedState_TransitionTime((int) 17126L),
  DiscrepancyAlarmType_AckedState_EffectiveTransitionTime((int) 17127L),
  DiscrepancyAlarmType_AckedState_TrueState((int) 17128L),
  DiscrepancyAlarmType_AckedState_FalseState((int) 17129L),
  DiscrepancyAlarmType_ConfirmedState((int) 17130L),
  DiscrepancyAlarmType_ConfirmedState_Id((int) 17131L),
  DiscrepancyAlarmType_ConfirmedState_Name((int) 17132L),
  DiscrepancyAlarmType_ConfirmedState_Number((int) 17133L),
  DiscrepancyAlarmType_ConfirmedState_EffectiveDisplayName((int) 17134L),
  DiscrepancyAlarmType_ConfirmedState_TransitionTime((int) 17135L),
  DiscrepancyAlarmType_ConfirmedState_EffectiveTransitionTime((int) 17136L),
  DiscrepancyAlarmType_ConfirmedState_TrueState((int) 17137L),
  DiscrepancyAlarmType_ConfirmedState_FalseState((int) 17138L),
  DiscrepancyAlarmType_Acknowledge_InputArguments((int) 17140L),
  DiscrepancyAlarmType_Confirm_InputArguments((int) 17142L),
  DiscrepancyAlarmType_ActiveState((int) 17143L),
  DiscrepancyAlarmType_ActiveState_Id((int) 17144L),
  DiscrepancyAlarmType_ActiveState_Name((int) 17145L),
  DiscrepancyAlarmType_ActiveState_Number((int) 17146L),
  DiscrepancyAlarmType_ActiveState_EffectiveDisplayName((int) 17147L),
  DiscrepancyAlarmType_ActiveState_TransitionTime((int) 17148L),
  DiscrepancyAlarmType_ActiveState_EffectiveTransitionTime((int) 17149L),
  DiscrepancyAlarmType_ActiveState_TrueState((int) 17150L),
  DiscrepancyAlarmType_ActiveState_FalseState((int) 17151L),
  DiscrepancyAlarmType_InputNode((int) 17152L),
  DiscrepancyAlarmType_SuppressedState((int) 17153L),
  DiscrepancyAlarmType_SuppressedState_Id((int) 17154L),
  DiscrepancyAlarmType_SuppressedState_Name((int) 17155L),
  DiscrepancyAlarmType_SuppressedState_Number((int) 17156L),
  DiscrepancyAlarmType_SuppressedState_EffectiveDisplayName((int) 17157L),
  DiscrepancyAlarmType_SuppressedState_TransitionTime((int) 17158L),
  DiscrepancyAlarmType_SuppressedState_EffectiveTransitionTime((int) 17159L),
  DiscrepancyAlarmType_SuppressedState_TrueState((int) 17160L),
  DiscrepancyAlarmType_SuppressedState_FalseState((int) 17161L),
  DiscrepancyAlarmType_OutOfServiceState((int) 17162L),
  DiscrepancyAlarmType_OutOfServiceState_Id((int) 17163L),
  DiscrepancyAlarmType_OutOfServiceState_Name((int) 17164L),
  DiscrepancyAlarmType_OutOfServiceState_Number((int) 17165L),
  DiscrepancyAlarmType_OutOfServiceState_EffectiveDisplayName((int) 17166L),
  DiscrepancyAlarmType_OutOfServiceState_TransitionTime((int) 17167L),
  DiscrepancyAlarmType_OutOfServiceState_EffectiveTransitionTime((int) 17168L),
  DiscrepancyAlarmType_OutOfServiceState_TrueState((int) 17169L),
  DiscrepancyAlarmType_OutOfServiceState_FalseState((int) 17170L),
  DiscrepancyAlarmType_SilenceState((int) 17171L),
  DiscrepancyAlarmType_SilenceState_Id((int) 17172L),
  DiscrepancyAlarmType_SilenceState_Name((int) 17173L),
  DiscrepancyAlarmType_SilenceState_Number((int) 17174L),
  DiscrepancyAlarmType_SilenceState_EffectiveDisplayName((int) 17175L),
  DiscrepancyAlarmType_SilenceState_TransitionTime((int) 17176L),
  DiscrepancyAlarmType_SilenceState_EffectiveTransitionTime((int) 17177L),
  DiscrepancyAlarmType_SilenceState_TrueState((int) 17178L),
  DiscrepancyAlarmType_SilenceState_FalseState((int) 17179L),
  DiscrepancyAlarmType_ShelvingState_CurrentState((int) 17181L),
  DiscrepancyAlarmType_ShelvingState_CurrentState_Id((int) 17182L),
  DiscrepancyAlarmType_ShelvingState_CurrentState_Name((int) 17183L),
  DiscrepancyAlarmType_ShelvingState_CurrentState_Number((int) 17184L),
  DiscrepancyAlarmType_ShelvingState_CurrentState_EffectiveDisplayName((int) 17185L),
  DiscrepancyAlarmType_ShelvingState_LastTransition((int) 17186L),
  DiscrepancyAlarmType_ShelvingState_LastTransition_Id((int) 17187L),
  DiscrepancyAlarmType_ShelvingState_LastTransition_Name((int) 17188L),
  DiscrepancyAlarmType_ShelvingState_LastTransition_Number((int) 17189L),
  DiscrepancyAlarmType_ShelvingState_LastTransition_TransitionTime((int) 17190L),
  DiscrepancyAlarmType_ShelvingState_LastTransition_EffectiveTransitionTime((int) 17191L),
  DiscrepancyAlarmType_ShelvingState_UnshelveTime((int) 17192L),
  DiscrepancyAlarmType_ShelvingState_TimedShelve_InputArguments((int) 17196L),
  DiscrepancyAlarmType_SuppressedOrShelved((int) 17197L),
  DiscrepancyAlarmType_MaxTimeShelved((int) 17198L),
  DiscrepancyAlarmType_AudibleEnabled((int) 17199L),
  DiscrepancyAlarmType_AudibleSound((int) 17200L),
  DiscrepancyAlarmType_OnDelay((int) 17205L),
  DiscrepancyAlarmType_OffDelay((int) 17206L),
  DiscrepancyAlarmType_FirstInGroupFlag((int) 17207L),
  DiscrepancyAlarmType_ReAlarmTime((int) 17210L),
  DiscrepancyAlarmType_ReAlarmRepeatCount((int) 17211L),
  DiscrepancyAlarmType_TargetValueNode((int) 17215L),
  DiscrepancyAlarmType_ExpectedTime((int) 17216L),
  DiscrepancyAlarmType_Tolerance((int) 17217L),
  DiscrepancyAlarmType_ShelvingState_AvailableStates((int) 17702L),
  DiscrepancyAlarmType_ShelvingState_AvailableTransitions((int) 17703L),
  DiscrepancyAlarmType_AudibleSound_ListId((int) 17977L),
  DiscrepancyAlarmType_AudibleSound_AgencyId((int) 17978L),
  DiscrepancyAlarmType_AudibleSound_VersionId((int) 17979L),
  DiscrepancyAlarmType_LatchedState((int) 18655L),
  DiscrepancyAlarmType_LatchedState_Id((int) 18656L),
  DiscrepancyAlarmType_LatchedState_Name((int) 18657L),
  DiscrepancyAlarmType_LatchedState_Number((int) 18658L),
  DiscrepancyAlarmType_LatchedState_EffectiveDisplayName((int) 18659L),
  DiscrepancyAlarmType_LatchedState_TransitionTime((int) 18660L),
  DiscrepancyAlarmType_LatchedState_EffectiveTransitionTime((int) 18661L),
  DiscrepancyAlarmType_LatchedState_TrueState((int) 18662L),
  DiscrepancyAlarmType_LatchedState_FalseState((int) 18663L),
  DiscrepancyAlarmType_Suppress2_InputArguments((int) 24499L),
  DiscrepancyAlarmType_Unsuppress2_InputArguments((int) 24501L),
  DiscrepancyAlarmType_RemoveFromService2_InputArguments((int) 24503L),
  DiscrepancyAlarmType_PlaceInService2_InputArguments((int) 24505L),
  DiscrepancyAlarmType_Reset2_InputArguments((int) 24507L),
  DiscrepancyAlarmType_ShelvingState_TimedShelve2_InputArguments((int) 24963L),
  DiscrepancyAlarmType_ShelvingState_Unshelve2_InputArguments((int) 24965L),
  DiscrepancyAlarmType_ShelvingState_OneShotShelve2_InputArguments((int) 24967L),
  DiscrepancyAlarmType_GetGroupMemberships_OutputArguments((int) 25175L),
  DiscrepancyAlarmType_SupportsFilteredRetain((int) 32243L);
  private static final Map<Integer, OpcuaNodeIdServicesVariableDiscrepancy> map;

  static {
    map = new HashMap<>();
    for (OpcuaNodeIdServicesVariableDiscrepancy value :
        OpcuaNodeIdServicesVariableDiscrepancy.values()) {
      map.put((int) value.getValue(), value);
    }
  }

  private final int value;

  OpcuaNodeIdServicesVariableDiscrepancy(int value) {
    this.value = value;
  }

  public int getValue() {
    return value;
  }

  public static OpcuaNodeIdServicesVariableDiscrepancy enumForValue(int value) {
    return map.get(value);
  }

  public static Boolean isDefined(int value) {
    return map.containsKey(value);
  }
}
